#include <fstream>
#include <vector>
#include <valarray>
#include <math.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <complex>

using namespace std;

/*
 * For a thorough documentation see "Hankel_Transformer.cpp".
 */
class Hankel_Transformer {

 public:

  Hankel_Transformer(int log_x, int log_y, valarray<double> x_in, valarray<double> y_in);
  ~Hankel_Transformer();
  
  void lognorm_to_Gaussian_P(double k0, valarray<double>* P);
  void lognorm_to_Gaussian_xi(double k0, valarray<double>* xi);
  void P_to_xi(int nu, valarray<double>* x_out, valarray<double>* y_out);
  void xi_to_P(int nu, valarray<double>* x_out, valarray<double>* y_out);
  
 private:
 
   
   valarray<double> x;
   valarray<double> y;
   
   void set_x_and_y(int log_x, int log_y, valarray<double> x_in, valarray<double> y_in);   
   
};
