#include "Grid.cpp"
#include <time.h>

using namespace std;


int main(int argc, char **argv){
  
  int index;
  int seed;
  
  stringstream str;
  str << argv[1];
  str >> index;
  
  seed = nth_prime_number(index);
  
  // The timers for computation time measurements are initialized.
  time_t timer1, timer2;
  time(&timer1);
  
  
  // Initializes the shear grid.
  Grid grid(seed);
  // Prints a mock galaxy survey.
  grid.print_shear_catalog(4000000, 0.25, 1, "./sources_bin1_sim_"+to_string(index)+".fits");
  grid.print_shear_catalog(4000000, 0.25, 2, "./sources_bin2_sim_"+to_string(index)+".fits");
  grid.print_clustered_galaxies(150000, 1.6, 0.0, 1, "./lenses_bin1_sim_"+to_string(index)+".fits");
  grid.print_clustered_galaxies(150000, 1.6, 0.0, 2, "./lenses_bin2_sim_"+to_string(index)+".fits");
  grid.print_random_points(1500000, "./randoms.fits");
  
  
  // time measurement
  time(&timer2);
  cout << "\nSimulation complete.\n";
  cout  <<  "The computation took " << fixed << difftime(timer2,timer1) << " sec.\n\n";
  return 0;
  
}

